function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (myTop.suspendDataCache && myTop.suspendDataCache.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'inside_investment_management', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50852,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:9201,v:'normalState'},{id:9947,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:1155532,v:'normalState'},{id:1155542,v:'normalState'},{id:1155552,v:'normalState'},{id:1155573,v:'normalState'},{id:1155588,v:'normalState'},{id:1155596,v:'normalState'},{id:1155610,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:1049499,v:'normalState'},{id:1049510,v:'normalState'},{id:1049527,v:'normalState'},{id:1049541,v:'normalState'},{id:1162481,v:'normalState'},{id:1156962,v:'normalState'},{id:1157006,v:'normalState'},{id:1165013,v:'normalState'},{id:1157144,v:'normalState'},{id:1157155,v:'normalState'},{id:1157166,v:'normalState'},{id:1157182,v:'normalState'},{id:1157196,v:'normalState'},{id:1157211,v:'normalState'},{id:1157307,v:'normalState'},{id:1157386,v:'normalState'},{id:1157397,v:'normalState'},{id:1157413,v:'normalState'},{id:1157427,v:'normalState'},{id:1157557,v:'normalState'},{id:1157688,v:'normalState'},{id:1157696,v:'normalState'},{id:1157704,v:'normalState'},{id:1157712,v:'normalState'},{id:1157726,v:'normalState'},{id:1157740,v:'normalState'},{id:1157754,v:'normalState'},{id:1157768,v:'normalState'},{id:1157990,v:'normalState'},{id:1158341,v:'normalState'},{id:1158371,v:'normalState'},{id:1159665,v:'normalState'},{id:1159688,v:'normalState'},{id:1187654,v:'normalState'},{id:1187667,v:'normalState'},{id:1187680,v:'normalState'},{id:1187693,v:'normalState'},{id:1187706,v:'normalState'},{id:1187723,v:'normalState'},{id:1187748,v:'normalState'},{id:1187769,v:'normalState'},{id:1187790,v:'normalState'},{id:1187799,v:'normalState'},{id:1187809,v:'normalState'},{id:1192751,v:'normalState'},{id:1192764,v:'normalState'},{id:1192777,v:'normalState'},{id:1192790,v:'normalState'},{id:1192803,v:'normalState'},{id:1192820,v:'normalState'},{id:1192844,v:'normalState'},{id:1192864,v:'normalState'},{id:1192884,v:'normalState'},{id:1192893,v:'normalState'},{id:1192903,v:'normalState'},{id:1196161,v:'normalState'},{id:1196174,v:'normalState'},{id:1196187,v:'normalState'},{id:1196200,v:'normalState'},{id:1196213,v:'normalState'},{id:1196230,v:'normalState'},{id:1196254,v:'normalState'},{id:1196274,v:'normalState'},{id:1196294,v:'normalState'},{id:1196303,v:'normalState'},{id:1196313,v:'normalState'},{id:1199718,v:'normalState'},{id:1199731,v:'normalState'},{id:1199744,v:'normalState'},{id:1199757,v:'normalState'},{id:1199770,v:'normalState'},{id:1199787,v:'normalState'},{id:1199811,v:'normalState'},{id:1199831,v:'normalState'},{id:1199851,v:'normalState'},{id:1199860,v:'normalState'},{id:1199870,v:'normalState'},{id:1202802,v:'normalState'},{id:1202815,v:'normalState'},{id:1202828,v:'normalState'},{id:1202841,v:'normalState'},{id:1202854,v:'normalState'},{id:1202871,v:'normalState'},{id:1202895,v:'normalState'},{id:1202915,v:'normalState'},{id:1202935,v:'normalState'},{id:1202944,v:'normalState'},{id:1202954,v:'normalState'},{id:937962,v:'normalState'},{id:1207515,v:'normalState'},{id:1207538,v:'normalState'},{id:1160145,v:'normalState'},{id:1160163,v:'normalState'},{id:1160180,v:'normalState'},{id:1160196,v:'normalState'},{id:1160212,v:'normalState'},{id:1160228,v:'normalState'},{id:1160244,v:'normalState'},{id:1160260,v:'normalState'},{id:1160276,v:'normalState'},{id:1160292,v:'normalState'},{id:1160308,v:'normalState'},{id:1160488,v:'normalState'},{id:1160499,v:'normalState'},{id:1160510,v:'normalState'},{id:1160526,v:'normalState'},{id:1160540,v:'normalState'},{id:1160555,v:'normalState'},{id:939477,v:'normalState'},{id:1160646,v:'normalState'},{id:1160657,v:'normalState'},{id:1160673,v:'normalState'},{id:1160687,v:'normalState'},{id:687477,v:'normalState'},{id:1160849,v:'normalState'},{id:1160893,v:'normalState'},{id:70221,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:1025142,v:'normalState'},{id:1025156,v:'normalState'},{id:1025256,v:'normalState'},{id:1025270,v:'normalState'},{id:1055301,v:'normalState'},{id:1055315,v:'normalState'},{id:321023,v:'normalState'},{id:321015,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:1055430,v:'normalState'},{id:1055444,v:'normalState'},{id:923576,v:'normalState'},{id:923590,v:'normalState'},{id:70100,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:625193,v:'normalState'},{id:625135,v:'normalState'},{id:625143,v:'normalState'},{id:625151,v:'normalState'},{id:625159,v:'normalState'},{id:625167,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
